﻿package  {
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import caurina.transitions.Tweener;
	import flash.external.ExternalInterface;
	import flash.display.StageScaleMode;
	import flash.display.StageAlign;
	
	public class Main extends MovieClip {
		
		private var _Btn:MovieClip;
		private var _width_max:Number = 800;
		private var _height_max:Number = 800;
		private var _width_min:Number = 150;
		private var _height_min:Number = 150;
		private var _sikas:Array;
		private var _sikaContainer:Sprite;
		private var _sikaCnt:Number = 10;
		
		public function Main() {
			init();
		}
		
		public function init() {
			
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			_sikaContainer = new Sprite();
			addChildAt(_sikaContainer , 0);
			
			_sikas = [];
			_Btn = this["Btn"];
			_Btn.addEventListener(MouseEvent.ROLL_OVER , rollOverHandler );
			_Btn.addEventListener(MouseEvent.ROLL_OUT , rollOutHandler );
			_Btn.buttonMode = true;
		}
		
		private function rollOverHandler(e:MouseEvent) {
			ExternalInterface.call("setFlashArea" , _width_max , _height_max );
			addSika();
		}
		
		private function rollOutHandler(e:MouseEvent) {
			delSika();
			
		}
		
		private function addSika() {
			
			for (var i:int = 0; i < _sikaCnt; i++) {
				var sika:MovieClip = new Sika();
				var delayNum:Number = Math.random() * 2 ;
				_sikaContainer.addChild(sika);
				sika.x = _width_max - sika.width;
				sika.y = Math.random() * _height_max;
				sika.scaleX = 0;
				sika.scaleY = 0;
				_sikas.push(sika);
				
				Tweener.addTween( sika , {
					scaleX : 1 ,
					scaleY : 1 ,
					time : 1 ,
					transition : "easeoutquad" ,
					delay : delayNum
				} );
				
				Tweener.addTween( sika , {
					x : -200 ,
					time : 3 ,
					transition : "easeoutquad" ,
					delay : delayNum
				} );
			}
		}
		
		private function delSika() {
			
			var delcnt:Number = 0;
			var sikalen:Number = _sikas.length;
			
			for (var i:int = 0; i < sikalen; i++) {
				var sika:MovieClip = _sikas.shift();
				Tweener.addTween( sika , {
					alpha : 0 ,
					time : 1 ,
					transition : "easeoutquad" , 
					onComplete : function() {
						this.parent.removeChild(this);
						delcnt ++;
						if ( delcnt >= sikalen) {
							ExternalInterface.call("setFlashArea" , _width_min , _height_min );
						}
					}
				} );
			}
		}
	}
	
}